Look = function(s)
    if not s.exam then
        status._command = 'Ничего особенного...';
		return true;
    end
    status._command = call(s,'exam');
	return true;
end

Take = function(s)
    if have(s) then
        status._command = 'Проверьте свой инвентарь!';
		return true;
    end
    if not s.transportable or s == rocket_fuel or s == uranium_pool or s == oil_puddle then
        status._command = 'Вы попробовали, но у вас не получилось.';
		return true;
    end
	if status._inv_count < status._inv_max then
		status._inv_count = status._inv_count + 1;
		take(s);
		status._command = 'O.K.';
		status_check(nil);
		return true
	end
	if status._inv_max == 2 then
		status._command = 'У вас только две руки.';
	elseif status._inv_max == 1 then
		status._command = 'У вас только одна рука.';
	else
		status._command = 'Вам все это не унести.';
	end
	return true;
end

Drop = function(s)
    if not have(s) then
        status._command = 'Проверьте свой инвентарь!';
		return true;
    end
    local r,v = call(here(), 'drop', deref(s))
    if not r then
        r,v = call(s,'drop');
    end
    if v ~= false then
        do_drop(s);
		status._command = 'O.K.';
	else
		status._command = r;
    end
	status_check(nil);
	return true;
end

do_drop = function(s, w)
    s = ref(s)
	status._inv_count = status._inv_count - 1;
	if status._inv_count < 0 then
		status._inv_count = 0;
	end
    drop(s, w);
end

Push = function(s)
    if not s.push then
        status._command = 'Вы осмотрелись, но не нашли ничего, на что можно нажать или сдвинуть. ';
		return true;
    end
    status._command = call(s,'push');
	status_check(nil);
	return true;
end

Break = function(s)
    if s.break_ then
 		status._command = call(s,'break_');
		status_check(nil);
    else
		if have(s) then
			if s == survival_suit and s._dress then
				status._command = 'Вы попробовали, но у вас не получилось. ';
			else
				if s == canister and not s._empty then
					objs():add('rocket_fuel');
				elseif s == bottle and not s._empty then
					objs():add('uranium_pool');
				elseif s == vial and not s._empty then
					objs():add('oil_puddle');
				end
				Delete_obj(s);
				status._command = 'O.K. Вы сделали это. ';
				status_check(nil);
			end
		else
			if s.transportable then
				status._command = 'Не получается, сперва надо взять это в руки. ';
			else
				status._command = 'Надо больше заниматься спортом! ';
			end
		end
	end
	return true
end

Eat = function(s)
    if not s.eat then
		if not s.transportable then
			status._command = 'Вы попробовали, но у вас не получилось. ';
		elseif not have(s) then
			status._command = 'Проверьте свой инвентарь! ';
		else
			status_check(nil);
			status._command = 'O.K. Вы сделали это. ';
			Delete_obj(s);
			status_check(nil);
		end
		return true
    end
    status._command = call(s,'eat');
	status_check(nil);
	return true
end

Give = function(s, w)
	local r, v, rr, vv;
	if not ref(w) then
		status._command = 'Что за дикие фантазии! ';
		return true;
	end
	if not have(s) then
		status._command = 'Проверьте свой инвентарь! ';
		return true;
	end
	if ref(w).accept then
		r, v = call(ref(w), 'accept', s);
		if v ~= false then
			status._command = r;
			status_check(nil);
			return true, v;
		end
	end
	if s.give then
		r, v = call(s, 'give', w);
		if v ~= false then
			status._command = r;
			status_check(nil);
			return true, v;
		end
	end
	status._command = 'К сожалению, он не может взять это. ';
	status_check(nil);
	return true;
end

UseOn = function(s, w)
	local r, v;
	if not s.useon and not w.used then
		status._command = 'Гм... Как это может сработать?... ';
		status_check(nil);
		return true;
	end
	if s.useon then
		r, v = call(s, 'useon', w);
		if r then
			status._command = r;
			status_check(nil);
			return true, v;
		end
	end
	if w.used then
		r, v = call(w, 'used', s);
		if r then
			status._command = r;
			status_check(nil);
			return true, v;
		end
	end
	status._command = 'Вы попробовали, но у вас не получилось. ';
	status_check(nil);
	return true;
end

UseIt = function(s)
	local r, v;
	if not s.useit then
		status._command = 'Гм... Как это может сработать?... ';
		status_check(nil);
		return true;
	end
	if s.transportable and not have(s) then
		status._command = 'Не получается, сперва надо взять это в руки. ';
		status_check(nil);
		return true;
	end
	r, v = call(s, 'useit');
	if not r then
		status._command = 'Вы попробовали, но у вас не получилось. ';
	else
		status._command = r;
	end
	status_check(nil);
	return true, v;
end

function iobj(v)
	v.act = Look;
	v.inv = Look;
	v.Exam = Look;
	v.Take = Take;
	v.Drop = Drop;
	v.Push = Push;
	v.Break = Break;
	v.Eat = Eat;
	v.Give = Give;
	v.Accept = Give;
	v.Useon = UseOn;
	--v.Used = UseOn;
	v.Useit = UseIt;
	return menu(v);
end

game.help = function(s)
	if here() == r_52 and lock_52._status == 1 then
		status._command = 'Может, надо еще что-нибудь сделать с ключом? ';
	elseif here() == r_35 and objs():srch('robot_35') and not robot_35._push then
		status._command = 'Ну дайте ему что-нибудь, пусть успокоится. ';
	elseif here() == r_35 and not objs():srch('robot_35') then
		status._command = 'И зачем вы взорвали бедного робота? Он же не виноват, что так выглядит. ';
	elseif here() == r_28 then
		status._command = 'Посмотрите в своем словаре. ';
	elseif button_red_7._enable and not r_16._catapult then
		status._command = 'Повнимательнее изучите Дядича Зяда. ';
	else
		status._command = 'Попробуйте подумать сами, может, придут какие умные мысли. ';
	end
    return true
end

game.listen = function(s)
	if here() == r_35 and objs():srch('robot_35') and not robot_35._push then
		status._command = 'Он говорит: "#$@&& #@$%*% %$ 0110100101110", что в переводе с машинного языка означает "Энергия на исходе, необходима подзарядка" ';
	elseif button_blue_7._enable and not r_16._catapult then
		status._command = 'Вы слышите шум работающего двигателя. ';
	elseif here() == r_22 and objs():srch('robot_22') and not robot_22._dead then
		status._command = 'Вы слышите страшный скрип. ';
	else
		status._command = 'Здесь абсолютно тихо. ';
	end
    return true
end

function actions_init()
	minv   = obj_menu('С СОБОЙ', 'Exam', false, true);
	mlook   = obj_menu('ОСМОТРЕТЬ', 'Exam', true);
	mtake   = obj_menu('ВЗЯТЬ', 'Take', true);
	mdrop   = obj_menu('ПОЛОЖИТЬ', 'Drop', false, true);
	mpush   = obj_menu('НАЖАТЬ, СДВИНУТЬ', 'Push', true);
	mbreak  = obj_menu('СЛОМАТЬ', 'Break', true, true);
	meat    = obj_menu('СЪЕСТЬ', 'Eat', false, true);
	muse    = use_menu('ИСПОЛЬЗОВАТЬ', 'Useon', 'Used', 'Useit', true, true);
	mgive   = use_menu('ОТДАТЬ', 'Give', 'Accept', false, true, true, true);
	mlisten = act_menu('СЛУШАТЬ', 'listen', true, true, true);
	mhelp   = act_menu('ПОМОЩЬ', 'help', true, true, true);
	put('compass', me());
	put('n', me());
	put('s', me());
	put('e', me());
	put('w', me());
	put('u', me());
	put('d', me());
	put('map_button', me());
    put(minv, me());
    put(mlook, me());
    put(mtake, me());
    put(mdrop, me());
    put(mpush, me());
    put(mbreak, me());
    put(meat, me());
    put(mgive, me());
    put(muse, me());
    put(mlisten, me());
    put(mhelp, me());
end

map_button = menu {
    nam = txtc ('КАРТА^'),
    inv = function ()
	walk (map)
    end,
}

function direction(n)
    return function()
        return compass:select(n);
    end
end

n = menu {
    nam = true,
    inv = direction(1),
};

s = menu {
    nam = true,
    inv = direction(2),
};

e = menu {
    nam = true,
    inv = direction(3),
};

w = menu {
    nam = true,
    inv = direction(4),
};

u = menu {
    nam = true,
    inv = direction(5),
};

d = menu {
    nam = true,
    inv = direction(6),
};

compass = stat {
    nam = function()
    	local dirs = {
    		n = '_north',
    		s = '_south',
    		e = '_east',
    		w = '_west',
    		u = '_up',
    		d = '_down',
    	};
    	local get_dir = function(s)
    		local nm = 'pic/compas_'..s;
    		local o = here()[dirs[s]]
    		if not o then nm = nm..'_' end
    		nm = img(nm..'.png');
    		if o then
    			nm = xref(nm, ref(s));
    		end
    		return nm
    	end
        return txtc(img('pic/compas_null.png')..
        		get_dir 'n'..
				img('pic/compas_null.png')..
        		get_dir 'u'..'^'..
        		get_dir 'w'..
        		img('pic/compas_c.png')..
        		get_dir 'e'..
      			img('pic/compas_p.png')..'^'..
				img('pic/compas_null.png')..
      			get_dir 's'..
				img('pic/compas_null.png')..
      			get_dir 'd')..'^';
    end,
    select = function(s, n)
		if n == 1 then
			status._command = 'Вы пошли на Север. ';
			return walk (here()._north);
        elseif n == 2 then
			status._command = 'Вы пошли на Юг. ';
			return walk (here()._south);
        elseif n == 3 then
			status._command = 'Вы пошли на Восток. ';
			return walk (here()._east);
        elseif n == 4 then
			status._command = 'Вы пошли на Запад. ';
			return walk (here()._west);
        elseif n == 5 then
			status._command = 'Вы пошли Вверх. ';
			return walk (here()._up);
        elseif n == 6 then
			status._command = 'Вы пошли Вниз. ';
			return walk (here()._down);
        end
    end
};

actions_init();
